#include <string>
#include <iostream>
#include <fstream>
#include <list>
#include "autosarasas.h"

using namespace std;


AutoSarasas::~AutoSarasas() {
   list<Auto*>::iterator vi;
   for (vi = autoSarasas.begin();  vi != autoSarasas.end();  vi++)
       delete (*vi);           // delete Auto objektus
       autoSarasas.clear();       // delete Auto nuorodas (pointers)
}


void AutoSarasas::printSarasa() {
   cout <<endl;
   cout << "-~-~-~-~-~-~-~-~-~-~-~-~-~-~-~-~-~-~-~-~-~-~-~-~-~-" << 
endl;
   autoSarasas.sort(Palyginti());
   list<Auto*>::iterator vi = autoSarasas.begin();

   for (;  vi != autoSarasas.end();  vi++)
      (*vi)->printAuto();
   cout << "-~-~-~-~-~-~-~-~-~-~-~-~-~-~-~-~-~-~-~-~-~-~-~-~-~-" << 
endl;
}


void AutoSarasas::isnuomoti() {
   string marke;
   bool busena;
   int pinigai;
   string data;
   cout << "Kurios markes auto norite isnuomuoti: ";
   cin >> marke;
   cout << "Data (MMMM-mm-dd): ";
   cin >> data;
   cout << "Pinigai: ";
   cin >> pinigai;

    list<Auto*>::iterator iter = autoSarasas.begin();
      for (;  iter != autoSarasas.end();  iter++) {
      string markeX = (*iter)->getAuto();
         if (markeX == marke) {
           if((*iter)->getBusena() == false) {
              (*iter)->setBusena();
              (*iter)->iSarasa(pinigai,data);
              break;
           }else
              cout<<"Siuo metu automobilis isnuomotas"<<endl;
         }
      }
}


void AutoSarasas::atsiimti() {
   string marke;
   cout << "Kurios markes auto norite atsiimti? ";
   cin >> marke;
   list<Auto*>::iterator iter = autoSarasas.begin();
      for (;  iter != autoSarasas.end();  iter++) {
      string markeX = (*iter)->getAuto();
         if (markeX == marke) {
            (*iter)->unsetBusena();
            break;
         }
      }
}


void AutoSarasas::createNewAuto(std::string marke, bool busena) {
   autoSarasas.push_back(new Auto(marke, busena));
}


void AutoSarasas::printPelnaPagalLaikotarpi() {
   string dataNuo;
   string dataIki;
   int i=0,pelnas=0;
   cout << "Nuo kada (MMMM-mm-dd): ";
   cin >> dataNuo;
   cout << "Iki kada (MMMM-mm-dd): ";
   cin >> dataIki;
   list<Auto*>::iterator iter = autoSarasas.begin();
   for (;  iter != autoSarasas.end();  iter++){
      i=(*iter)->printAutoPelnas(dataNuo, dataIki);
      pelnas=pelnas+i;
   }
   cout<<"Pelnas: "<<pelnas<< "Lt"<<endl;
}


void AutoSarasas::printPelna() {
   string dataNuo;
   string dataIki;
   int i=0,pelnas=0;
   list<Auto*>::iterator iter = autoSarasas.begin();
   for (;  iter != autoSarasas.end();  iter++){
      i=(*iter)->printVisaPelna();
      pelnas=pelnas+i;
   }
   cout<<"Bendras pelnas: "<<pelnas<<" Lt"<<endl;
}


void AutoSarasas::printVienoAutoSutarti(){
   string marke;
   cout << "Nurodykite auto marke: ";
   cin >> marke;
   list<Auto*>::iterator iter = autoSarasas.begin();
   for (;  iter != autoSarasas.end();  iter++) {
      string markeX = (*iter)->getAuto();
      if (markeX == marke)
         (*iter)->printAuto();
   }
}


void AutoSarasas::toFile() {
   ofstream outFile("output.txt");
   autoSarasas.sort(Palyginti());
   list<Auto*>::iterator vi = autoSarasas.begin();
   for (;  vi != autoSarasas.end();  vi++)
      (*vi)->autoToFile(outFile);
   outFile.close();
}
